



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>电子词典的相关子函数db.c程序</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">电子词典的相关子函数db.c程序</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 13:07:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>整个电子词典是分块做的：包含的Dic_Server.c,Dic_Client.c,db.c,query.c,xprtcl.c,dict.h,xprtcl.h,dict.txt(单词文件)</p>
<p>下面是db.c代码：主要用创建子进程实现服务器端的并发操作</p>
<p>#include &lt;stdio.h&gt;<br />#include &lt;stdlib.h&gt;<br />#include &lt;string.h&gt;<br />#include &lt;sqlite3.h&gt;</p>
<p>#include "dict.h"<br />#include "xprtcl.h"</p>
<p>#define DATABASE "dict.db"<br />#define T_USERS		"users"		/* table name for login users */<br />#define T_HISTORY	"history"	/* table name for query history */<br />#define MAXLEN_SQL 256</p>
<p>sqlite3 *g_db = NULL;<br />const char *login_name;<br />const char *login_passwd;</p>
<p>void db_close()<br />{<br />	if (sqlite3_close(g_db) != SQLITE_OK) {<br />		fprintf(stderr, <br />			"error: close database: %s\n", <br />			sqlite3_errmsg(g_db));<br />	}<br />}</p>
<p>static int cb_tbl_isexist(<br />	void* arg, <br />	int count, <br />	char** column_value, <br />	char** column_name)<br />{<br />	dprintf("cb_tbl_isexist was called once\n");<br />	*((int*)arg) = 1; /* set existence flag as 1 */<br />	return 0;<br />}</p>
<p>static int tbl_isexist(sqlite3 *db, const char *table_name)<br />{<br />	char	sqlstr[MAXLEN_SQL];</p>
<p>int	exist;<br />	char	*errmsg;</p>
<p>if (snprintf(sqlstr, MAXLEN_SQL, <br />		"select name from sqlite_master "<br />		"where type='table' and name='%s'", table_name) &lt; 0) {<br />		dprintf("snprintf SQL error");	<br />		return 0;<br />	}<br />	dprintf("SQL: %s\n", sqlstr);</p>
<p>/* <br />	 * Note: this flag "exist" will be passed into the callback.<br />	 * If the callback occurred, it will be modified by <br />	 * the callback internally.<br />	 */<br />	exist = 0; <br />	if (SQLITE_OK != sqlite3_exec(<br />		db, <br />		sqlstr, <br />		cb_tbl_isexist, <br />		&amp;exist, <br />		&amp;errmsg)) {<br />		dprintf("sqlite3_exec error (table[%s] existence): %s\n", <br />			table_name, errmsg);<br />		sqlite3_free(errmsg);<br />	}<br />	return exist;<br />}</p>
<p>static int tbl_create_usrs(sqlite3 *db)  /*在数据库中创建需要的表格:usrs*/<br />{<br />	char	sqlstr[MAXLEN_SQL];<br />	char	*errmsg;</p>
<p>if (1 == tbl_isexist(db, T_USERS))  /*如果创建的表存在，退出*/<br />	{<br />		dprintf("table users already exists\n");<br />		return 0;<br />	}</p>
<p>if (snprintf(<br />		sqlstr, <br />		MAXLEN_SQL, <br />		"create table users(usrname text, passwd text, state text);"<br />		) &lt; 0) {<br />		perror("snprintf error");<br />		return -1;<br />	}<br />	dprintf("SQL: %s\n", sqlstr);</p>
<p>if (SQLITE_OK != sqlite3_exec(<br />		db, <br />		sqlstr, <br />		NULL, <br />		NULL, <br />		&amp;errmsg)) {<br />		fprintf(stderr, "error: create users: %s\n", errmsg);<br />		sqlite3_free(errmsg);<br />		return -1;<br />	}</p>
<p>return 0;<br />}</p>
<p>static int tbl_create_history(sqlite3 *db)  /*在数据库中创建需要的表格:usrs*/<br />{<br />	char	sqlstr[MAXLEN_SQL];<br />	char	*errmsg;</p>
<p>if (1 == tbl_isexist(db, T_HISTORY))  /*如果创建的表存在，退出*/<br />	{<br />		dprintf("table history already exists\n");<br />		return 0;<br />	}</p>
<p>if (snprintf(<br />		sqlstr, <br />		MAXLEN_SQL, <br />		"create table history(usrname text, word text, time text);"<br />		) &lt; 0) {<br />		perror("snprintf error");<br />		return -1;<br />	}<br />	dprintf("SQL: %s\n", sqlstr);</p>
<p>if (SQLITE_OK != sqlite3_exec(<br />		db, <br />		sqlstr, <br />		NULL, <br />		NULL, <br />		&amp;errmsg)) {<br />		fprintf(stderr, "error: create users: %s\n", errmsg);<br />		sqlite3_free(errmsg);<br />		return -1;<br />	}</p>
<p>return 0;<br />}</p>
<p>int db_init()<br />{<br />	int result;</p>
<p>result = sqlite3_open(DATABASE, &amp;g_db);<br />	if (result != SQLITE_OK) <br />	{<br />		if (NULL != g_db)<br />		{<br />			fprintf(stderr, "error: open database: %s\n",<br />			sqlite3_errmsg(g_db));<br />		} <br />		else <br />		{<br />			fprintf(stderr, "error: failed to allocate memory!\n");<br />		}<br />		return -1;<br />	}</p>
<p>if (tbl_create_usrs(g_db) &lt; 0) {<br />		goto _error_exit;<br />	}</p>
<p>if (tbl_create_history(g_db) &lt; 0) {<br />		goto _error_exit;<br />	}</p>
<p>return 0;</p>
<p>_error_exit:<br />	db_close();<br />	return -1;<br />}</p>
<p>static int cb_user_isexist(<br />	void* arg, <br />	int count, <br />	char** column_value, <br />	char** column_name)<br />{<br />	dprintf("cb_user_isexist was called once\n");<br />	*((int*)arg) = 1;	 /* set existence flag as 1 */<br />	return 0;<br />}</p>
<p>static int user_isexist(sqlite3 *db, const char *user_name,const char *user_passwd)<br />{<br />	char	sqlstr[MAXLEN_SQL];</p>
<p>int	exist;<br />	char	*errmsg;</p>
<p>if (snprintf(sqlstr, MAXLEN_SQL, <br />		"select * from %s "<br />		"where usrname='%s'", T_USERS, user_name) &lt; 0) {<br />		dprintf("snprintf SQL error");	<br />		return 0;<br />	}<br />	dprintf("SQL: %s\n", sqlstr);</p>
<p>/* <br />	 * Note: this flag "exist" will be passed into the callback.<br />	 * If the callback occurred, it will be modified by <br />	 * the callback internally.<br />	 */<br />	exist = 0; <br />	if (SQLITE_OK != sqlite3_exec(<br />		db, <br />		sqlstr, <br />		cb_user_isexist, <br />		&amp;exist, <br />		&amp;errmsg)) {<br />		dprintf("sqlite3_exec error (user[%s] existence): %s\n", <br />			user_name, errmsg);<br />		sqlite3_free(errmsg);<br />	}<br />	return exist;<br />}</p>
<p>/*注册的账号*/<br />int tbl_insert_users(const char *name, const char *passwd)<br />{<br />	char	sqlstr[MAXLEN_SQL];<br />	char	*errmsg;</p>
<p>/* validating syntax of username and passwd ...... */</p>
<p>/* checking if user exists with the input name */</p>
<p>if (user_isexist(g_db, name, passwd))    /*账号已存在，退出*/<br />	{<br />		return -1;	<br />	}</p>
<p>/* in case passed checking */  /*账号不存在，向数据库中录入账号和密码*/<br />	if (snprintf(sqlstr, MAXLEN_SQL, "insert into users values('%s', '%s', '0')",<br />				name, passwd)&lt; 0)<br />	{<br />		perror("snprintf error");<br />		return -1;<br />	}<br />	dprintf("SQL: %s\n", sqlstr);</p>
<p>if (SQLITE_OK != sqlite3_exec(g_db, sqlstr, NULL, NULL, &amp;errmsg))<br />	{<br />		fprintf(stderr, "error: insert users: %s\n", errmsg);<br />		sqlite3_free(errmsg);<br />		return -1;<br />	}</p>
<p>return 0;<br />}<br />/*登录验证的回调函数*/<br />static int login_user_isexist(<br />	void* arg, <br />	int count, <br />	char** column_value, <br />	char** column_name)<br />{<br />	//int i=0;<br />	char	sqlstr[MAXLEN_SQL];<br />	char	*errmsg;<br />	dprintf("cb_user_isexist was called once\n");<br />	if((*column_value[0] == *login_name) &amp;&amp; (*column_value[1] == *login_passwd))<br />	{   <br />		if((*column_value[2])== '0')  /*验证账号是否已登录*/</p>
<p>{	<br />			//printf("entry this function\n");<br />			if (snprintf(sqlstr, MAXLEN_SQL, <br />				"update users set state = 1 where usrname = '%s'",<br />				column_value[0])&lt; 0)<br />			{<br />				perror("snprintf error");<br />				return -1;<br />			}<br />			dprintf("SQL: %s\n", sqlstr);</p>
<p>if (SQLITE_OK != sqlite3_exec(g_db, sqlstr, NULL, NULL, &amp;errmsg))<br />			{<br />				fprintf(stderr, "error: insert users: %s\n", errmsg);<br />				sqlite3_free(errmsg);<br />				return -1;<br />			}<br />			*((int*)arg) = 1;/*set existence flag as 1 */<br />		}<br />		if((*column_value[2])== '1')<br />		{<br />			*((int*)arg) = 2;<br />		}<br />	}<br />	return 0;<br />}</p>
<p>static int login_user_true(sqlite3 *db, const char *user_name,const char *user_passwd)<br />{<br />	char	sqlstr[MAXLEN_SQL];</p>
<p>int	exist;<br />	char	*errmsg;</p>
<p>if (snprintf(sqlstr, MAXLEN_SQL, <br />		"select * from %s "<br />		"where usrname='%s'", T_USERS, user_name) &lt; 0) {<br />		dprintf("snprintf SQL error");	<br />		return 0;<br />	}<br />	dprintf("SQL: %s\n", sqlstr);</p>
<p>/* <br />	 * Note: this flag "exist" will be passed into the callback.<br />	 * If the callback occurred, it will be modified by <br />	 * the callback internally.<br />	 */<br />	exist = 0; <br />	if (SQLITE_OK != sqlite3_exec(<br />		db, <br />		sqlstr, <br />		login_user_isexist, <br />		&amp;exist, <br />		&amp;errmsg)) {<br />		dprintf("sqlite3_exec error (user[%s] existence): %s\n", <br />			user_name, errmsg);<br />		sqlite3_free(errmsg);<br />	}<br />	return exist;<br />}</p>
<p>/*验证登陆账号是否注册*/<br />int login_users(const char *name, const char *passwd)<br />{<br />	//char	sqlstr[MAXLEN_SQL];<br />	//char	*errmsg;<br />	int login_flag;</p>
<p>login_name = name;<br />	login_passwd = passwd;</p>
<p>/* validating syntax of username and passwd ...... */</p>
<p>/* checking if user exists with the input name */<br />	login_flag = login_user_true(g_db, name, passwd);<br />	if (login_flag==1)    /*账号是否已注册和登录*/<br />	{<br />		printf("login successfuly\n");<br />		return 0;<br />	}<br />	if(login_flag==2)  /*账号已登录*/<br />	{<br />		printf("Accounts have been online\n");<br />		return 1;<br />	}</p>
<p>return -1; <br />}</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2070l9.html">web前端教程之javascript创建对象的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j3jg0q.html">javascript中数组揭秘</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zr3o29.html">Oracle逻辑读详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvr1x1q.html">MVC学习系列&mdash;&mdash;记一次失败面试后，感想。</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xzpkz8.html">一次配置jdk环境变量的感悟</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0r2wwq.html">jQuery实现购物车多物品数量的加减&plus;总价&plus;删除计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6jgj9.html">JAVA之Exchanger</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypnmz8.html">robotium测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpkw2vq.html">C&num; 中关于接口实现、显示实现接口以及继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me6e5oq.html">Redis sentinel &amp;amp&semi; cluster 原理分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m0zln8.html">&lbrack;LeetCode&rsqb; Maximum Binary Tree 最大二叉树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpmje8.html">MongoDB 最大连接数 设置失效的异常分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m22werq.html">SSM环境的搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjom709.html">使用Vivado的block design</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pd74r8.html">Python Web学习笔记之Python多线程基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9637k3y9.html">POJ 3694 Network（并查集缩点 &plus; 朴素的LCA &plus; 无向图求桥）题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pnkvnq.html">DIY微型操作系统（2）&mdash;&mdash; 寄存器赋值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emwe5z9.html">jQuery DataTables插件分页允许输入页码跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk76rn8.html">hdu4758 Walk Through Squares</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl3g239.html">PHP对象的复制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq1x1y08.html">基于Opencv和Mfc的图像处理增强库GOCVHelper&lpar;索引&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy3pjx8.html">不用安装Oracle&lowbar;Client就能使用PLSQL&lowbar;Developer</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql0ze0q.html">Maven学习（一） -- 安装Maven及Eclipse中配置Maven</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy3e628.html">Git 忽略文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9ponyzq.html">《BI项目笔记》无法解密受保护的 XML 节点&OpenCurlyDoubleQuote;DTS&colon;Password&rdquo; 解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnzjjkq.html">使用 InstallShield 制作 Delphi 软件安装包</a>
			</li>
						<li><a href="https://www.batexi.com/a/390xmjj9.html">MFC编程入门之九（对话框&colon;为控件添加消息处理函数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd4p40q.html">Server asks us to fall back to SIMPLE auth&comma; but this client is configured to only allow secure connections&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m72z08.html">Cryptopp iOS 使用 RSA加密解密和签名验证签名</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rr5oe9.html">C&num;MongoDB使用实践</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
